<?php

global $amp_conf;
global $db;

require_once($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/functions.inc.php");

$update=0;

// Update database schema if updating from 1.1
$results = $db->getAll("DESC fop2buttons");
$campos = count($results);
if($campos < 16) {
    $query="ALTER TABLE `fop2buttons` ADD `customastdb` varchar(50) default '' AFTER originatechannel";
    sql($query);
    $query="ALTER TABLE `fop2buttons` ADD `spyoptions` varchar(100) default '' AFTER customastdb";
    sql($query);
    $query="ALTER TABLE `fop2buttons` ADD `channel` varchar(200) default '' AFTER mailbox";
    sql($query);
    $query="ALTER TABLE `fop2buttons` ADD `external` varchar(100) default '' AFTER spyoptions";
    sql($query);
    $query="ALTER TABLE `fop2UserGroup` change `exten` `exten` varchar(20)";
    sql($query);
    $update=1;
}

$results = $db->getAll("DESC fop2permissions");
if(!$results) {
    $query = "CREATE TABLE IF NOT EXISTS `fop2permissions` (
                         `id` int(11) NOT NULL auto_increment,
                         `context_id` int(11) default NULL,
                         `name` varchar(30) default NULL,
                         `permissions` varchar(200) default NULL,
                         PRIMARY KEY  (`id`)
                         ) DEFAULT CHARSET=UTF8";
    sql($query);
}

$results = $db->getAll("DESC fop2PermGroup");
if(!$results) {
    $query = "CREATE TABLE IF NOT EXISTS `fop2PermGroup` (
                         `id` int(11) NOT NULL auto_increment,
                         `name` varchar(30) default NULL,
                         `id_group` int(11) default NULL,
                         `name_group` varchar(100) default NULL,
                         PRIMARY KEY  (`id`)
                       ) DEFAULT CHARSET=UTF8";
    sql($query);
}

$results = $db->getAll("DESC fop2templates");
if(!$results) {
    $query = "CREATE TABLE `fop2templates` (
                   `id` int(11) NOT NULL auto_increment,
                   `name` varchar(30) default NULL,
                   `permissions` varchar(200) default NULL,
                   `groups` varchar(200) default NULL,
                   `isdefault` int(6) default '0',
                   PRIMARY KEY  (`id`)
                 )   DEFAULT CHARSET=UTF8";
    sql($query);
}

// ******************************************

$botonesdefinidos = fop2_list_botones();
$fopbutton        = fop2_all_freepbx_buttons();

$ver = getversion();
$ver = str_replace(".","",substr($ver,0,3));

if($ver>25) {
   $qctx="from-queue";
} else {
   $qctx="from-internal";
}

foreach ($fopbutton as $devname => $datarray) {
   $tipocorto = substr($datarray['type'],0,-1);

       if($tipocorto == "extension") {
           $cfstring="CF/".$datarray['exten'];
           $qchanstr="Local/".$datarray['exten']."@$qctx/n";
       } else {
           $cfstring="NULL";
           $qchanstr="NULL";
       }

   if(!isset($botonesdefinidos[$devname])) {
        if($datarray['name']=="") { $datarray['name'] = $devname;}
        $results = sql( "REPLACE INTO fop2buttons (type, device, privacy, label, exten, context, mailbox, queuechannel, customastdb) ".
                        "VALUES ('$tipocorto', '$devname', '', '".mysql_real_escape_string($datarray['name'])."','".$datarray['exten']."','".$datarray['context']."','".$datarray['mailbox']."','$qchanstr','$cfstring')");
        if(DB::IsError($results)) {
            die($results->getMessage());
        } else {
            $botonesdefinidos[$devname]=1;
        };
    } else {
        if($update==1) {
            $results = sql ( "UPDATE fop2buttons SET customastdb='$cfstring' WHERE type='$tipocorto' AND device='$devname'");
        }
    }
}

/*
$allbuttons= fop2_list_buttons();

$results = sql("INSERT INTO fop2groups (id,name) VALUES ('1','all')","query");

foreach ($allbuttons as $devname => $datarray) {
   sql("INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('all','".$datarray['id']."')", "query");
}
*/

$freepbxusers = core_users_list();
// La primera extension tiene todos los permisos
if(!isset($freepbxusers)) {
   $freepbxusers = Array();
}
$permisos="all";
foreach($freepbxusers as $key=>$val) {
    if($val[2]<>"novm") {
        $exten = $val[0];
        $results = sql( "SELECT id FROM fop2users WHERE exten='$exten' LIMIT 1", "getRow",DB_FETCHMODE_ASSOC);
        if(!$results) {
            $results = sql ("INSERT INTO fop2users (exten,secret,permissions) VALUES ('$exten','','$permisos')", "query");
            // Las demas solo pueden discar, transferir o capturar
            $permisos="dial,transfer,pickup,phonebook";
            if(DB::IsError($results)) {
                die($results->getMessage());
            }
            $results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$exten',1)","query");
            if(DB::IsError($results)) {
                die($results->getMessage());
            }
        }
    }
} 

?>
